# hcny

基于 nnrm 修改的 npm 源管理器，这是一个私有的工具，内置了私有npm仓库源。

hcny = 泓创 npm、yarn （h = 泓、c = 创、n = npm、 y = yarn）

## 请先全局安装此库

```sh

npm install -g hcny --registry http://39.108.216.210:9000/

```

## 使用

以下命令是用来切换对应的包管理工具的源。

- `hcny` & `hnrm`: npm
- `hyrm`: yarn（v1-v3）
- `hprm`: pnpm

```sh
# 列出所有可用的源
hcny ls
# hnrm ls
# hyrm ls
# hprm ls

# 切换源
hcny use hc
# hnrm use hc
# hyrm use hc
# hprm use hc

# 设置本地的 `.npmrc`
hnrm use hc -l

#测试源的响应时间
hcny test
# hnrm test
# hyrm test
# hprm test
```

## 切换到私有的npm仓库

```sh

#如果您使用 npm
hnrm use hc

#如果您使用 yarn
hyrm use hc

#如果您使用 pnpm
hprm use hc

```

- `hnrm -h`: 显示帮助信息

```bash
Usage:
  $ hnrm <command> [options]

Commands:
  ls                           List all the registries
  use [registry]               Change registry
  test                         Show response time for all registries
  add <registry> <url> [home]  Add a custom registry
  remove <registry>            Remove a custom registry

Options:
  -h, --help     Display this message
  -v, --version  Display version number
```

```bash
Usage:
  $ hnrm use [registry]

Options:
  -l, --local    set '.npmrc' for local
```

### 添加/删除自定义源

```sh
# 添加自定义源
hcny add example https://xxx.com
```

```sh
# 移除自定义源
hnrm remove example
```

---


它将会被记录在你的 `~/.hcny/registries.json`。

### 默认源

- npm -------- <https://registry.npmjs.org/>
- yarn ------- <https://registry.yarnpkg.com/>
- taobao ----- <https://registry.npmmirror.com/> 
- tencent ---- <https://mirrors.cloud.tencent.com/npm/>
- npmMirror -- <https://skimdb.npmjs.com/registry/>
- github ----- <https://npm.pkg.github.com/>
- hc ----- <http://39.108.216.210:9000/> （私有npm仓库源）


## 如果你不想使用 hcny ，也可以自行修改 npm 或 yarn 的配置

#### 如果你使用npm，推荐你可以在需要时带上 --registry 参数，避免影响其它npm库


```shell

#安装全部依赖
npm install --registry http://39.108.216.210:9000/

#安装某个依赖
npm install 包名称 --registry http://39.108.216.210:9000/

#注册一个私有npm仓库账号，不发包的话，不需要注册
npm adduser --registry http://39.108.216.210:9000/

#登录到私有npm仓库，不发包的话，不需要登录
npm login --registry http://39.108.216.210:9000/

#发表到私有npm仓库，不发包的话，不需要推送
npm publish --registry http://39.108.216.210:9000/

```


## yarn 不支持以上 npm 的操作，需要切换镜像源后，再执行相关操作

```shell

#设置为私有npm仓库的镜像源
yarn config set registry http://39.108.216.210:9000/

#设置为yarn官方的镜像源
yarn config set registry https://registry.yarnpkg.com/

```

---


## FAQ

### Windows 报错？

如果您是 Windows 用户，您可能需要确保你使用 `bash` 等类 UNIX 通用命令行（而非 CMD）。

## 参考

- [npm-config | npm Docs](https://docs.npmjs.com/cli/v7/commands/npm-config)
